
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
using namespace std;
struct node
{
    long long sum;
    int max;
    int max_pos;
    int lazy = -1;
    node(){}
    node(int x, int pos)
    {
        max_pos = pos;
        max = sum = x;
    }
    node(node a, node b)
    {
        if (a.max > b.max){
            max = a.max;
            max_pos = a.max_pos;
        }
        else{
            max = b.max;
            max_pos = b.max_pos;
        }
        sum = a.sum + b.sum;
    }
    void get_pushed(int _lazy, int size)
    {
        max = lazy = _lazy;
        sum = (long long)_lazy * size;
    }
};
struct segment_tree
{
    std::vector<node> nodes;
    int ext_size;
    segment_tree(std::vector<int> &h)
    {
        ext_size = 1;
        while (ext_size < h.size())
            ext_size *= 2;
        nodes.resize(ext_size * 2);
        for (int i = ext_size; i < ext_size+h.size(); i++)
        {
            nodes[i] = node(h[i - ext_size], i-ext_size);
        }
        for (int i = ext_size - 1; i >= 1; i--)
        {
            nodes[i] = node(nodes[i * 2], nodes[i * 2 + 1]);
        }
    }
    void push(int node, int node_l, int node_r)
    {
        if (node >= ext_size)
            return;
        int _lazy = nodes[node].lazy;
        if (_lazy == -1)
            return;
        int size = node_r - node_l + 1;
        size /= 2;
        nodes[node].lazy = -1;
        nodes[node * 2].get_pushed(_lazy, size);
        nodes[node * 2 + 1].get_pushed(_lazy, size);
    }
    void set(int node_id, int node_l, int node_r, int l, int r, int x)
    {
        if (node_l > r || node_r < l)
            return;
        if (l <= node_l && node_r <= r)
        {
            nodes[node_id].get_pushed(x, node_r - node_l + 1);
            return;
        }
        push(node_id, node_l, node_r);
        int mid = (node_l + node_r) / 2;
        set(node_id * 2, node_l, mid, l, r, x);
        set(node_id * 2 + 1, mid + 1, node_r, l, r, x);
        nodes[node_id] = node(nodes[node_id * 2], nodes[node_id * 2 + 1]);
    }
    node get(int node_id, int node_l, int node_r, int l, int r)
    {
        if (node_l > r || node_r < l)
            return node(0, -1);
        if (l <= node_l && node_r <= r)
        {
            return nodes[node_id];
        }
        push(node_id, node_l, node_r);
        int mid = (node_l + node_r) / 2;
        auto leftc = get(node_id * 2, node_l, mid, l, r);
        auto rightc = get(node_id * 2 + 1, mid + 1, node_r, l, r);
        return node(leftc, rightc);
    }
    node get(int l, int r){
        return get(1, 0, ext_size-1, l, r);
    }
    void set(int l, int r, int x){
        if (l > r)
            return;
        if (l == -1)
            return;
        if (r == -1)
            return;
        return set(1, 0, ext_size-1, l, r, x);
    }
    int pref_obhod(int node, int under, int size){
        if (node >= ext_size){
            return nodes[node].max_pos;
        }
        push(node, 0, size);
        if (nodes[node*2].max >= under)
            return pref_obhod(node*2, under, size/2);
        return pref_obhod(node*2+1, under, size/2);
    }
    int suff_obhod(int node, int under, int size){
        if (node >= ext_size){
            return nodes[node].max_pos;
        }
        push(node, 0, size);
        if (nodes[node*2+1].max >= under)
            return suff_obhod(node*2+1, under, size/2);
        return suff_obhod(node*2, under, size/2);
    }
    int get_pref(int node_id, int node_l, int node_r, int l, int r, int under)
    {
        if (nodes[node_id].max < under)
            return -1;
        if (node_l > r || node_r < l)
            return -1;
        if (l <= node_l && node_r <= r)
        {
            return pref_obhod(node_id, under, node_r-node_l+1)-1;
        }
        push(node_id, node_l, node_r);
        int mid = (node_l + node_r) / 2;
        auto leftc = get_pref(node_id * 2, node_l, mid, l, r, under);
        if (leftc != -1)
            return leftc;
        return get_pref(node_id * 2 + 1, mid + 1, node_r, l, r, under);
    }
    int get_suff(int node_id, int node_l, int node_r, int l, int r, int under)
    {
        if (nodes[node_id].max < under)
            return -1;
        if (node_l > r || node_r < l)
            return -1;
        if (l <= node_l && node_r <= r)
        {
            return suff_obhod(node_id, under, node_r-node_l+1)+1;
        }
        push(node_id, node_l, node_r);
        int mid = (node_l + node_r) / 2;
        auto rightc = get_suff(node_id * 2 + 1, mid + 1, node_r, l, r, under);
        if (rightc != -1)
            return rightc;
        return get_suff(node_id * 2, node_l, mid, l, r, under);
    }
    int get_pref(int l, int r, int x){
        if (l > r)
            return -1;
        if (l == -1)
            return -1;
        if (r == -1)
            return -1 ;
        return get_pref(1, 0, ext_size-1, l, r, x);
    }
    int get_suff(int l, int r, int x){
        if (l > r)
            return -1;
        if (l == -1)
            return -1;
        if (r == -1)
            return -1 ;
        return get_suff(1, 0, ext_size-1, l, r, x);
    }
};
int main()
{
    int n;
    cin >> n;
    tree<int, null_type, std::less<int>, rb_tree_tag, tree_order_statistics_node_update> segments;
    std::vector<int> h(n);
    std::vector<long long> pref_sum(n+1);
    pref_sum[0] = 0;
    for (int i = 0; i < n; i++){
        cin >> h[i];
        segments.insert(i);
        pref_sum[i+1] = pref_sum[i] + h[i];
    }
    segment_tree our_tree(h);
    for (int _ = 1; _ < n; _++)
    {
        int k;
        cin >> k;
        auto mid_it = segments.find_by_order(k);
        auto left_it = mid_it;
        auto end_it = mid_it;
        left_it--;
        end_it++;
        int left=  *left_it;
        int mid = *mid_it;
        int end = n;
        if (end_it != segments.end())
            end = *end_it;
        segments.erase(mid_it);
        node m1 = our_tree.get(left, mid-1);
        node m2 = our_tree.get(mid, end-1);
        int minimum = std::min(m1.max, m2.max);
        int left_set = 0;
        int right_set = n;
        if (m1.max < m2.max){
            left_set = m1.max_pos+1;
            right_set = our_tree.get_pref(left_set, end-1, minimum);
        }
        else {
            right_set = m2.max_pos-1;
            left_set = our_tree.get_suff(left, right_set, minimum);
        }
        our_tree.set(std::max(left_set, left), std::min(right_set, end-1), minimum);
        long long result = our_tree.get(left, end-1).sum - (pref_sum[end] - pref_sum[left]);
        cout << result << '\n';
    }
    
    return 0;
}