#include <vector>
#include <unordered_map>
#include <algorithm>
#include <ios>
#include <iostream>
#include <cstdint>
using namespace std;
constexpr int mod = 1e9 + 7;
int n, k;
struct vector_hash
{
    uint64_t operator()(const std::vector<int>& x) const
    {
        uint64_t result = 0;
        for (auto e : x)
        {
            result <<= 3;
            result |= e;
        }
        return result;
    }
};
void inc(std::vector<int>& key)
{
    for (int i = 0; i < k - 1; i++)
    {
        if (key[i] < k - i - 1)
        {
            key[i]++;
            break;
        }
        key[i] = 0;
    }
}
int sum(const std::vector<int>& key)
{
    int result = 0;
    for (auto e : key)
        result += e;
    return result;
}
int bin_pow(int base, int exp){
    int result = 1;
    while (exp){
        if (exp & 1){
            result = (int64_t)result * base % mod;
        }
        base = (int64_t)base * base % mod;
        exp >>= 1;
    }
    return result;
}
int facts[10];
int inv_facts[10];
void compute_fact(){
    facts[0] = 1;
    for (int i = 1; i < 10; i++){
        facts[i] = (int64_t)facts[i-1] * i % mod;
    }
    for (int i = 0; i < 10; i++)
        inv_facts[i] = bin_pow(facts[i], mod-2);
}
int C(int a, int b){
    if (b > a)
        return 0;
    return (int64_t)facts[a] * inv_facts[b] % mod * inv_facts[a-b] % mod;
}
int key_weight(int last_b, const std::vector<int>& key){
    int last = last_b-sum(key);
    int result = 1;
    for (int i = 0; i < k - 1; i++)
    {
        result = (int64_t) result * C(k-i-1, key[i]) % mod;
    }
    result = (int64_t) result * C(k, last) % mod;
    return result;
}
std::vector<int> from;
int main()
{
    compute_fact();
    std::ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> k;
    int fact_k = 1;
    int old_b = 0;
    int max_b = (k) * (k + 1) / 2;
    for (int i = 2; i <= k; i++)
        fact_k *= i;
    std::vector<std::unordered_map<std::vector<int>, int, vector_hash>> dp(n + 1);
    
    dp[0][vector<int>(k - 1, 0)] = 1;
    for (int i = 1; i <= n; i++)
    {
        int b;
        cin >> b;
        if (b > max_b || (abs(b - old_b)) > k)
        {
            cout << "0\n";
            return 0;
        }
        std::vector<int> key(k - 1, 0);
        for (int _ = 0; _ < fact_k; _++, inc(key))
        {
            int sum_of_key = sum(key);
            if (sum_of_key < old_b - k || sum_of_key > old_b || sum_of_key > b || sum_of_key < b - k)
              continue;
            std::vector<int> base(k-1, 0);
            if (k != 1){

                base = std::vector<int>(key.begin() + 1, key.end());
                base.push_back(0);
            }
            std::vector<int> delta(k - 1, 0);
            // у последнего слоя мы удаляли
            if (old_b - sum_of_key - 1 >= 0 && old_b - sum_of_key - 1 < k)
            {
                fill_n(delta.rbegin(), old_b - sum_of_key - 1, 1);
                do
                {
                    from = base;
                    for (int j = 0; j < base.size(); j++)
                    {
                        from[j] += delta[j];
                        if (from[j] > k - j - 1)
                            goto double_break;
                    }
                    dp[i][key] += dp[i - 1][from];
                    if (dp[i][key] >= mod)
                        dp[i][key] -= mod;
                double_break:
                0 + 0;
                } while (next_permutation(delta.begin(), delta.end()));
            }
            if (old_b - sum_of_key < 0 || old_b - sum_of_key >= k)
                continue;
            // мы не удаляли
            fill_n(delta.rbegin(), old_b - sum_of_key, 1);
            do
            {
                from = base;
                for (int j = 0; j < base.size(); j++)
                {
                    from[j] += delta[j];
                    if (from[j] > k - j - 1)
                        goto double2_break;
                }
                dp[i][key] += dp[i - 1][from];
                if (dp[i][key] >= mod)
                    dp[i][key] -= mod;
            double2_break:
                0 + 0;
            } while (next_permutation(delta.begin(), delta.end()));
        }
        old_b = b;
    }
    int result = 0;
    for (const auto& [k, v] : dp.back())
    {
        result += ((int64_t)v * key_weight(old_b, k)) % mod;
        result %= mod;
    }
    cout << result << '\n';
    return 0;
}