#include <bits/stdc++.h>
using namespace std;
constexpr int mod = 1e9 + 7;
constexpr int max_fact = 1e6;
int facts[max_fact + 1];
int inv_facts[max_fact + 1];
int bin_pow(int base, int exp)
{
    int result = 1;
    while (exp)
    {
        if (exp & 1)
        {
            result = (int64_t)result * base % mod;
        }
        base = (int64_t)base * base % mod;
        exp >>= 1;
    }
    return result;
}
int inverse(int x)
{
    return bin_pow(x, mod - 2);
}
void compute_facts()
{
    facts[0] = 1;
    for (int i = 1; i <= max_fact; i++)
    {
        facts[i] = (int64_t)facts[i - 1] * i % mod;
    }
    inv_facts[max_fact] = inverse(facts[max_fact]);
    for (int i = max_fact; i > 0; i--)
    {
        inv_facts[i - 1] = inv_facts[i] * (int64_t)i % mod;
    }
}
void add_to(std::vector<std::vector<int>> &to, const std::vector<std::vector<int>> &from)
{
    for (int i = 0; i < to.size(); i++)
    {
        for (int j = 0; j < to[i].size(); j++)
        {
            to[i][j] += from[i][j];
            if (to[i][j] >= mod)
                to[i][j] -= mod;
        }
    }
}
int sum_of(const std::vector<std::vector<int>> &from)
{
    return from[0][0];
}
int32_t main()
{
    compute_facts();
    int n, m, k;
    cin >> n >> m >> k;
    std::vector dp1(n + 2, std::vector(m + 2, vector(n + 2, vector(m + 2, 0))));
    dp1[1][1][0][0] = 1;
    std::vector<std::pair<int, int>> dosto(k);
    for (auto &[x, y] : dosto)
        std::cin >> x >> y;
    std::vector<std::vector<int>> bins(m + 2);
    for (auto [x, y] : dosto)
    {
        bins[y].push_back(x);
    }
    for (auto &bin : bins)
        sort(bin.begin(), bin.end());
    std::vector<int> min_x(m + 2, n + 1);

    std::vector<int> max_x(m + 2, 0);
    for (auto [x, y] : dosto)
    {
        min_x[y] = std::min(min_x[y], x);
    }
    for (auto [x, y] : dosto)
    {
        max_x[y] = std::max(max_x[y], x);
    }
    for (int x = 1; x <= n; x++)
    {
        for (int y = 1; y <= m; y++)
        {
            if (x == 1 && y == 1)
                continue;
            add_to(dp1[x][y], dp1[x - 1][y]);
            if (x <= min_x[y])
            {
                add_to(dp1[x][y], dp1[x][y - 1]);
            }
            dp1[x][y][x][y] = sum_of(dp1[x][y]);
        }
    }
    std::vector<std::vector<std::vector<int>>> dp2(n + 2, std::vector(m + 2, std::vector<int>(n + 2)));
    dp2[1][1][1] = 1;
    // dp2 - колво
    for (int y = 2; y <= m; y++)
    {
        for (int end_x = max_x[y - 1]; end_x <= n; end_x++)
        {
            for (int begin_x = 1; begin_x <= end_x; begin_x++)
            {
                auto last_dosto = lower_bound(bins[y - 1].begin(), bins[y - 1].end(), begin_x);
                int last_x = -1;
                int last2_x = -1;
                auto last2_dosto = lower_bound(bins[y].begin(), bins[y].end(), end_x);
                if (last_dosto != bins[y - 1].begin())
                {
                    last_dosto--;
                    last_x = *last_dosto;
                }
                if (last2_dosto != bins[y].begin())
                {
                    last2_dosto--;
                    last2_x = *last2_dosto;
                }
                if (y == 2){
                    last_x = 1;
                }
                if (y == m && end_x == n)
                    last2_x = n;
                if (last2_x != -1 && last_x != -1)
                {
                    dp2[end_x][y][last2_x] += (int64_t)dp2[begin_x][y - 1][last_x] * (mod + 1 - (int64_t)dp1[last2_x][y][begin_x][y - 1] * inverse(dp1[last2_x][y][last_x][y - 1]) % mod) % mod;
                    dp2[end_x][y][last2_x] %= mod;
                }
                else if (last2_x != -1){
                    for (int i = 0; i < begin_x; i++){
                        
                        dp2[end_x][y][last2_x] += (int64_t)dp2[begin_x][y - 1][i] * (mod + 1 - (int64_t)dp1[last2_x][y][begin_x][y - 1] * inverse(dp1[last2_x][y][i][y - 1]) % mod) % mod;
                        dp2[end_x][y][last2_x] %= mod;
                    }
                }
                else if (last_x != -1){
                    for (int i = last_x; i < end_x; i++){
                        
                        dp2[end_x][y][i] += (int64_t)dp2[begin_x][y - 1][last_x] * (mod + 1 - (int64_t)dp1[i][y][begin_x][y - 1] * inverse(dp1[i][y][last_x][y - 1]) % mod) % mod;
                        dp2[end_x][y][i] %= mod;
                    }
                }
                else{
                    for (int i = 0; i < begin_x; i++){
                            
                        for (int j = i; j < end_x; j++){
                            
                            dp2[end_x][y][i] += (int64_t)dp2[begin_x][y - 1][i] * (mod + 1 - (int64_t)dp1[j][y][begin_x][y - 1] * inverse(dp1[j][y][i][y - 1]) % mod) % mod;
                            dp2[end_x][y][i] %= mod;
                        }
                    }
                }
            }
        }
    }
    int result = 0;
    for (int i : dp2[n][m]){
        result += i;
        if (result >= mod)
            result -= mod;
    }
    cout << result * 2 % mod << '\n';
    return 0;
}